patch for Copy set of tables to new name pattern.
[phpmyadmin/dennischen.git] / scripts / create-release.sh
blob5846662868ea279a16b04577dc12fcf047b3fc40
1 #!/bin/sh
3 # vim: expandtab sw=4 ts=4 sts=4:
6 # More documentation about making a release is available at:
7 # http://wiki.phpmyadmin.net/pma/Devel:Releasing
9 # Fail on undefined variables
10 set -u
11 # Fail on failure
12 set -e
14 KITS="all-languages english"
15 COMPRESSIONS="zip-7z tbz txz tgz 7z"
17 if [ $# -lt 2 ]
18 then
19 echo "Usages:"
20 echo " create-release.sh <version> <from_branch> [--tag]"
21 echo ""
22 echo "If --tag is specified, relase tag is automatically created"
23 echo ""
24 echo "Examples:"
25 echo " create-release.sh 2.9.0-rc1 QA_2_9"
26 echo " create-release.sh 2.9.0 MAINT_2_9_0 --tag"
27 exit 65
31 # Checks whether remote branch has local tracking branch
32 ensure_local_branch() {
33 if ! git branch | grep -q '^..'"$1"'$' ; then
34 git branch --track $1 origin/$1
38 # Marks current head of given branch as head of other branch
39 # Used for STABLE/TESTING tracking
40 mark_as_release() {
41 branch=$1
42 rel_branch=$2
43 echo "* Marking release as $rel_branch"
44 ensure_local_branch $rel_branch
45 git checkout $rel_branch
46 git merge -s recursive -X theirs $branch
49 # Read required parameters
50 version=$1
51 shift
52 branch=$1
53 shift
55 cat <<END
57 Please ensure you have incremented rc count or version in the repository :
58 - in libraries/Config.class.php PMA_Config::__constructor() the line
59 " \$this->set( 'PMA_VERSION', '$version' ); "
60 - in Documentation.html the 2 lines
61 " <title>phpMyAdmin $version - Documentation</title> "
62 " <h1>phpMyAdmin $version Documentation</h1> "
63 - in README
65 Continue (y/n)?
66 END
67 read do_release
69 if [ "$do_release" != 'y' ]; then
70 exit 100
73 # Ensure we have tracking branch
74 ensure_local_branch $branch
76 # Create working copy
77 mkdir -p release
78 workdir=release/phpMyAdmin-$version
79 if [ -d $workdir ] ; then
80 echo "Working directory '$workdir' already exists, please move it out of way"
81 exit 1
83 git clone --local . $workdir
84 cd $workdir
86 # Checkout branch
87 ensure_local_branch $branch
88 git checkout $branch
90 # Check release version
91 if ! grep -q "'PMA_VERSION', '$version'" libraries/Config.class.php ; then
92 echo "There seems to be wrong version in libraries/Config.class.php!"
93 exit 2
95 if ! grep -q "phpMyAdmin $version - Documentation" Documentation.html ; then
96 echo "There seems to be wrong version in Documentation.html"
97 exit 2
99 if ! grep -q "Version $version\$" README ; then
100 echo "There seems to be wrong version in README"
101 exit 2
104 # Cleanup release dir
105 LC_ALL=C date -u > RELEASE-DATE-${version}
107 # Building Documentation.txt
108 echo "* Generating Documentation.txt"
109 LC_ALL=C w3m -dump Documentation.html > Documentation.txt
111 # Check for gettext support
112 if [ -d po ] ; then
113 GETTEXT=1
114 else
115 GETTEXT=0
118 # Generate mo files
119 if [ $GETTEXT -eq 1 ] ; then
120 echo "* Generating mo files"
121 ./scripts/generate-mo
122 echo "* Removing gettext source files"
123 rm -rf po
126 if [ -f ./scripts/compress-js ] ; then
127 echo "* Compressing javascript files"
128 ./scripts/compress-js
129 rm -rf sources
132 echo "* Removing unneeded files"
134 # Remove test directory from package to avoid Path disclosure messages
135 # if someone runs /test/wui.php and there are test failures
136 rm -rf test
138 # Remove javascript compiler, no need to ship it
139 rm -rf scripts/google-javascript-compiler/
141 # Remove scripts which are not useful for user
142 for s in compress-js create-release.sh generate-mo mergepo.py php2gettext.sh remove_control_m.sh update-po upload-release pending-po pendingpo.py ; do
143 rm -f scripts/$s
144 done
146 # Remove git metadata
147 rm -rf .git
148 find . -name .gitignore -print0 | xargs -0 -r rm -f
150 cd ..
152 # Prepare all kits
153 for kit in $KITS ; do
154 # Copy all files
155 name=phpMyAdmin-$version-$kit
156 cp -r phpMyAdmin-$version $name
158 # Cleanup translations
159 cd phpMyAdmin-$version-$kit
160 scripts/lang-cleanup.sh $kit
161 rm -f scripts/lang-cleanup.sh
162 cd ..
164 # Remove tar file possibly left from previous run
165 rm -f $name.tar
167 # Prepare distributions
168 for comp in $COMPRESSIONS ; do
169 case $comp in
170 tbz|tgz|txz)
171 if [ ! -f $name.tar ] ; then
172 echo "* Creating $name.tar"
173 tar cf $name.tar $name
175 if [ $comp = tbz ] ; then
176 echo "* Creating $name.tar.bz2"
177 bzip2 -9k $name.tar
179 if [ $comp = txz ] ; then
180 echo "* Creating $name.tar.xz"
181 xz -9k $name.tar
183 if [ $comp = tgz ] ; then
184 echo "* Creating $name.tar.gz"
185 gzip -9c $name.tar > $name.tar.gz
188 zip)
189 echo "* Creating $name.zip"
190 zip -q -9 -r $name.zip $name
192 zip-7z)
193 echo "* Creating $name.zip"
194 7za a -bd -tzip $name.zip $name > /dev/null
197 echo "* Creating $name.7z"
198 7za a -bd $name.7z $name > /dev/null
201 echo "WARNING: ignoring compression '$comp', not known!"
203 esac
205 # Cleanup
206 rm -f $name.tar
207 done
209 # Remove directory with current dist set
210 rm -rf $name
211 done
213 # Cleanup
214 rm -rf phpMyAdmin-${version}
217 echo ""
218 echo ""
219 echo ""
220 echo "Files:"
221 echo "------"
223 ls -la *.gz *.zip *.bz2 *.7z
225 cd ..
228 if [ $# -gt 0 ] ; then
229 echo
230 echo "Additional tasks:"
231 while [ $# -gt 0 ] ; do
232 param=$1
233 case $1 in
234 --tag)
235 tagname=RELEASE_`echo $version | tr . _ | tr '[:lower:]' '[:upper:]' | tr -d -`
236 echo "* Tagging release as $tagname"
237 git tag -a -m "Released $version" $tagname $branch
238 if echo $version | grep -q '^2\.11\.' ; then
239 echo '* 2.11 branch, no STABLE/TESTING update'
240 else
241 if echo $version | grep '[a-z_-]' ; then
242 mark_as_release $branch TESTING
243 else
244 # We update both branches here
245 # As it does not make sense to have older testing than stable
246 if echo $version | grep -q '^3\.3\.' ; then
247 echo '* 3.3 branch, no TESTING update'
248 else
249 mark_as_release $branch TESTING
251 mark_as_release $branch STABLE
253 git checkout master
255 echo " Dont forget to push tags using: git push --tags"
258 echo "Unknown parameter: $1!"
259 exit 1
260 esac
261 shift
262 done
263 echo
266 cat <<END
269 Todo now:
270 ---------
272 1. If not already done, tag the repository with the new revision number
273 for a plain release or a release candidate:
274 version 2.7.0 gets two tags: RELEASE_2_7_0 and STABLE
275 version 2.7.1-rc1 gets RELEASE_2_7_1RC1 and TESTING
277 2. prepare a release/phpMyAdmin-$version-notes.html explaining in short the goal of
278 this release and paste into it the ChangeLog for this release
279 3. upload the files to SF, you can use scripts/upload-release, eg.:
281 ./scripts/upload-release \$USER $version release
282 4. add SF news item to phpMyAdmin project
283 5. announce release on freshmeat (http://freshmeat.net/projects/phpmyadmin/)
284 6. send a short mail (with list of major changes) to
285 phpmyadmin-devel@lists.sourceforge.net
286 phpmyadmin-news@lists.sourceforge.net
287 phpmyadmin-users@lists.sourceforge.net
289 Don't forget to update the Description section in the announcement,
290 based on Documentation.html.
292 7. increment rc count or version in the repository :
293 - in libraries/Config.class.php PMA_Config::__constructor() the line
294 " \$this->set( 'PMA_VERSION', '2.7.1-dev' ); "
295 - in Documentation.html the 2 lines
296 " <title>phpMyAdmin 2.2.2-rc1 - Documentation</title> "
297 " <h1>phpMyAdmin 2.2.2-rc1 Documentation</h1> "
299 8. add a group for bug tracking this new version, at
300 https://sourceforge.net/tracker/admin/index.php?group_id=23067&atid=377408&add_group=1
302 9. the end :-)